//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// List hosts in the cluster
//

register_command("lshosts", "List known hosts in the cluster");

function lshosts_help() {
    local command_help = {
        name = "lshosts"
        usage = "lshosts"
        description = "List known hosts in the cluster. This command prints the name of hosts detected by the last autodetection."
        parameters = []
        see_also = ["auto"]
    };

    print_command_help(command_help);
}

function lshosts(args) {
    local hostList = stringToObject(Application.getInstance().getHostListForSquirrel());
    print(hostList.len() + (hostList.len() == 1 ? " host" : " hosts") + " found in the cluster: ");

    for(local i=0; i<hostList.len(); i++)
	print(hostList[i] + (i+1!=hostList.len() ? ", " : "\n" ));
}
