//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// Cluster autodetection
//

register_command("quit", "Quit from application");

function quit_help() {
    local command_help = {
	name = "quit"
	usage = "quit|q"
	description = "Quit from application. If the benchmark is running, this command also stops that."
	parameters = []
	see_also = ["stop"]
    };
    
    print_command_help(command_help);
}

function quit(args) {

    if(Application.getInstance().getCompRun()) {
	stop([]);
    }

    print("Quiting...\n");
    Application.getInstance().quit();
}

function q(args) {
    quit(args);
}
