//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// Resolve abbreviations
//

function resolve_abbreviation(line) {

    // Strip spaces
    line = strip(line);

    // Split into words
    local words = split(line, " ");
    
    if(words.len() > 0 && typeof stringToObject(words[0]) == "function") {
	local rline = words[0] + "([";

	for(local i=1; i<words.len(); i++)
	    rline += "\"" + stringReplace(words[i], "\"", "\\\"") + (i+1<words.len() ? "\", " : "\"" );
	rline += "])";

	return rline;
    }

    /*
    // If the line contains only single words, convert to function call
    if(line.len() > 0 && line.find("(") == null && line.find(")") == null) {
	local words = split(line, " ");
	local rline = words[0] + "([";

	for(local i=1; i<words.len(); i++)
	    rline += "\"" + words[i] + (i+1<words.len() ? "\", " : "\"" );
	rline += "])";

	return rline;
    }
    */

    return line;
}
