//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// Dynamic script initialization
//

// Create empty low-level script
function createEmptyLowLevelScript(lowLevelScriptName, cluster) {
    // Create low-level script with default parameters
    local lowLevelScript = {
        name = lowLevelScriptName

	// No hosts
        hosts = []
	
	// No contexts
        contexts = []
    }

    // Add hosts
    foreach(host in cluster.hosts) {
	lowLevelScript.hosts.append({
	    name = host.address
	    nodes = []
	});
    }
    
    return lowLevelScript;
}

// Initialize dynamic script parameters (reset or complete)
function initializeDynamicScriptParameters(reset) {

    if(reset || !rawin("DYNAMICSCRIPTPARAMETERS")) {
	DYNAMICSCRIPTPARAMETERS<-{};
    }

    // Put default values into global parameter object
    local paramDescription = getDynamicScriptParameters();
    foreach(par in paramDescription) {
	if(par.rawin("defaultValue") && par.defaultValue != null && (!DYNAMICSCRIPTPARAMETERS.rawin(par.name) || reset))
	    DYNAMICSCRIPTPARAMETERS[par.name]<-par.defaultValue;
    }
}

// Set environment variables from C++ core code to squirrel
function setEnvironmentVariables(envVarsStr) {
    // Convert parameter to table
    ENVIRONMENTVARIABLES<-stringToObject(envVarsStr);
}
