
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMApplication_impl.h
/// Contains header implementation of class Application

 //
 // Getters & setters
 //

inline const std::string & Application::getLibrarySearchPath()
{
  return mLibrarySearchPath;
}

 /*-------------------------------------------------------------------------*/

inline void Application::setLibrarySearchPath(const std::string & librarysearchpath)
{
  mLibrarySearchPath = librarysearchpath;
}

 /*-------------------------------------------------------------------------*/

inline HostInfo *Application::getHostInfo() const
{
  return mHostInfo;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Application::getInitialized() const
{
  return mInitialized;
}

 /*-------------------------------------------------------------------------*/

inline const Application::PostCommand & Application::getPostCommand() const
{
  return mPostCommand;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Application::getQuiting() const
{
  return mQuiting;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Application::getOutputIsDone() const
{
  return mOutputIsDone;
}

 /*-------------------------------------------------------------------------*/

inline OutputNode::Pointer & Application::getOutputDocument()
{
  return mOutputDocument;
}

 /*-------------------------------------------------------------------------*/

inline OutputNode::Pointer & Application::getCurrentExecutionOutputDocument()
{
  return mCurrentExecutionOutputDocument;
}

 /*-------------------------------------------------------------------------*/

inline u32 & Application::getExecutionIndex()
{
  return mExecutionIndex;
}

 /*-------------------------------------------------------------------------*/

inline OutputNode::Pointer & Application::getCollectClusterDescription()
{
  return mCollectClusterDescription;
}

 /*-------------------------------------------------------------------------*/

inline ConfigOptions::Pointer & Application::getConfigOptions()
{
  return mConfigOptions;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Application::getLowLevelScript() const
{
  return mLowLevelScript;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Application::getDynamicScript() const
{
  return mDynamicScript;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Application::getScenarioScript() const
{
  return mScenarioScript;
}

 /*-------------------------------------------------------------------------*/

inline const std::list < std::string > &Application::getSquirrelCommandList() const
{
  return mSquirrelCommandList;
}

 /*-------------------------------------------------------------------------*/

inline bool & Application::getDynamicScriptCompiled()
{
  return mDynamicScriptCompiled;
}

 /*-------------------------------------------------------------------------*/

inline void Application::setDynamicScriptCompiled(const bool dynamicscriptcompiled)
{
  mDynamicScriptCompiled = dynamicscriptcompiled;
}

 /*-------------------------------------------------------------------------*/

inline NetServer *Application::getServer() const
{
  return mServer;
}

 /*-------------------------------------------------------------------------*/

inline NetClient *Application::getClient() const
{
  return mClient;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Application::getUsageString()
{
  return mUsageString;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Application::getCommanderMode()
{
  return mCommanderMode;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Application::getGUIMode()
{
  return mGUIMode;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Application::getManualClusterDescription()
{
  return mManualClusterDescription;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Application::getClusterDescription()
{
  return mClusterDescription;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Application::getLowLevelMode()
{
  return mLowLevelMode;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Application::getInteractiveParameters()
{
  return mInteractiveParameters;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Application::getParameters()
{
  return mParameters;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Application::getInput()
{
  return mInput;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Application::getOutput()
{
  return mOutput;
}

 /*-------------------------------------------------------------------------*/

inline int &Application::getExpectedHostCount()
{
  return mExpectedHostCount;
}

 /*-------------------------------------------------------------------------*/

inline const Application::UserInterface & Application::getUserInterface()
{
  return mUserInterface;
}

 /*-------------------------------------------------------------------------*/

inline bool & Application::getCompRun()
{
  return mCompRun;
}

 /*-------------------------------------------------------------------------*/
