
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMCPU_impl.h
/// Contains header implementation of class CPU

 //
 // Getters & setters
 //

inline const std::string & CPU::getVendor() const
{
  return mVendor;
}

 /*-------------------------------------------------------------------------*/

inline void CPU::setVendor(const std::string & vendor)
{
  mVendor = vendor;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & CPU::getModel() const
{
  return mModel;
}

 /*-------------------------------------------------------------------------*/

inline void CPU::setModel(const std::string & model)
{
  mModel = model;
}

 /*-------------------------------------------------------------------------*/

inline const Real & CPU::getClock() const
{
  return mClock;
}

 /*-------------------------------------------------------------------------*/

inline void CPU::setClock(const Real & clock)
{
  mClock = clock;
}

 /*-------------------------------------------------------------------------*/

inline const u32 & CPU::getCache() const
{
  return mCache;
}

 /*-------------------------------------------------------------------------*/

inline void CPU::setCache(const u32 & cache)
{
  mCache = cache;
}

 /*-------------------------------------------------------------------------*/

inline const Real & CPU::getBogomips() const
{
  return mBogomips;
}

 /*-------------------------------------------------------------------------*/

inline void CPU::setBogomips(const Real & bogomips)
{
  mBogomips = bogomips;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & CPU::getFlags() const
{
  return mFlags;
}

 /*-------------------------------------------------------------------------*/

inline void CPU::setFlags(const std::string & flags)
{
  mFlags = flags;
}

 /*-------------------------------------------------------------------------*/
