
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMClasses.h
/// Contains declarations of all classes of ParCompMark

#ifndef __PCM_CLASSES_H__
#  define __PCM_CLASSES_H__

//
// Class predeclaration
//

/**
  This namespace contains the classes of project ParCompMark. 
  The source files starts with <tt> PCM </tt> prefix.
  There is a unit test for this project called ParCompMarkTest.
*/
namespace ParCompMark
{

  class Network;
  class Thread;
  class Application;
  class Logger;
  class Exception;
   template < typename T > class Singleton;
   template < typename T, class Lock > class Pointer;
  class Lock;
  class DummyLock;
  class Mutex;
  class HandleClient;
  class Cluster;
  class Host;
  class Name;
  class DynLoad;
  class Buffer;
  class Context;
  class Node;
  class Process;
  class GLXGLContext;
  class GLXRenderWindow;
  class XDisplay;
  class SqVM;
  class OutputNode;
   template < class ElementType, class LockType > class Container;
  class Timer;
  class HostInfo;
  class OpenGLRenderingEngine;
  class FileSystemManager;
  class CPU;
  class GPU;
  class StringConverter;
  class ConfigOptions;
  class NetServer;
  class NetClient;
  class Client;
  class PluginManager;
  class Plugin;
  class RendererPlugin;
  class Renderer;
  class OpenGLExtensionLoader;
  class PCWrapper;

}

/**
  This namespace contains the classes of project ParCompMarkTest.
  The source files starts with <tt>Test</tt> prefix.
  This is a unit test project for project ParCompMark.
*/
namespace ParCompMarkTest
{

  class TestNetwork;

  class TestThread;

  class TestApplication;

  class TestLogger;

  class TestException;

  class TestSingleton;

  class TestPointer;

  class TestLock;

  class TestDummyLock;

  class TestMutex;

  class TestHandleClient;

  class TestCluster;

  class TestHost;

  class TestName;

  class TestDynLoad;

  class TestBuffer;

  class TestContext;

  class TestNode;

  class TestProcess;

  class TestGLXGLContext;

  class TestGLXRenderWindow;

  class TestXDisplay;

  class TestSqVM;

  class TestOutputNode;

  class TestContainer;

  class TestTimer;

  class TestHostInfo;

  class TestOpenGLRenderingEngine;

  class TestFileSystemManager;

  class TestCPU;

  class TestGPU;

  class TestStringConverter;

  class TestConfigOptions;

  class TestNetServer;

  class TestNetClient;

  class TestClient;

  class TestPluginManager;

  class TestPlugin;

  class TestRendererPlugin;

  class TestRenderer;

  class TestOpenGLExtensionLoader;

  class TestPCWrapper;

}

// Global headers in this project

#endif
