
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMContext_impl.h
/// Contains header implementation of class Context

 //
 // Getters & setters
 //

inline const int &Context::getID() const
{
  return mID;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setID(const int &id)
{
  mID = id;
}

 /*-------------------------------------------------------------------------*/

inline bool & Context::getUseGLFrameletEXT()
{
  return mUseGLFrameletEXT;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setUseGLFrameletEXT(const bool useglframeletext)
{
  mUseGLFrameletEXT = useglframeletext;
}

 /*-------------------------------------------------------------------------*/

inline Context::ContextType & Context::getContextType()
{
  return mContextType;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setContextType(const Context::ContextType & contexttype)
{
  mContextType = contexttype;
}

 /*-------------------------------------------------------------------------*/

inline PCid & Context::getFrameID()
{
  return mFrameID;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getFrameWidth()
{
  return mFrameWidth;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setFrameWidth(const PCint framewidth)
{
  mFrameWidth = framewidth;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getFrameHeight()
{
  return mFrameHeight;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setFrameHeight(const PCint frameheight)
{
  mFrameHeight = frameheight;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getColourFormat()
{
  return mColourFormat;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setColourFormat(const PCint colourformat)
{
  mColourFormat = colourformat;
  mPixelFormat = mColourFormat | mDepthFormat;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getDepthFormat()
{
  return mDepthFormat;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setDepthFormat(const PCint depthformat)
{
  mDepthFormat = depthformat;
  mPixelFormat = mColourFormat | mDepthFormat;
}

 /*-------------------------------------------------------------------------*/

inline const PCint & Context::getPixelFormat() const
{
  return mPixelFormat;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getCompositeType()
{
  return mCompositeType;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setCompositeType(const PCint compositetype)
{
  mCompositeType = compositetype;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getCompressionHint()
{
  return mCompressionHint;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setCompressionHint(const PCint compressionhint)
{
  mCompressionHint = compressionhint;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getRetainOutputCount()
{
  return mRetainOutputCount;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setRetainOutputCount(const PCint retainoutputcount)
{
  mRetainOutputCount = retainoutputcount;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getVolatileFrameletCount()
{
  return mVolatileFrameletCount;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setVolatileFrameletCount(const PCint volatileframeletcount)
{
  mVolatileFrameletCount = volatileframeletcount;
}

 /*-------------------------------------------------------------------------*/

inline bool & Context::getOutputDepth()
{
  return mOutputDepth;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setOutputDepth(const bool outputdepth)
{
  mOutputDepth = outputdepth;
}

 /*-------------------------------------------------------------------------*/

inline PCstring *Context::getProcesses() const
{
  return mProcesses;
}

 /*-------------------------------------------------------------------------*/

inline const PCint & Context::getProcessCount() const
{
  return mProcessCount;
}

 /*-------------------------------------------------------------------------*/

inline int &Context::getProcessIndex()
{
  return mProcessIndex;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setProcessIndex(const int processindex)
{
  mProcessIndex = processindex;
}

 /*-------------------------------------------------------------------------*/

inline const PCint & Context::getHostIndex() const
{
  return mHostIndex;
}

 /*-------------------------------------------------------------------------*/

inline PCint & Context::getNetworkID()
{
  return mNetworkID;
}

 /*-------------------------------------------------------------------------*/

inline void Context::setNetworkID(const PCint networkid)
{
  mNetworkID = networkid;
}

 /*-------------------------------------------------------------------------*/

inline const PCcontext & Context::getContext() const
{
  return mContext;
}

 /*-------------------------------------------------------------------------*/

inline Process *Context::getParent()
{
  return mParent;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Context::getInitialized() const
{
  return mInitialized;
}

 /*-------------------------------------------------------------------------*/

 //
 // Methods
 //

inline void Context::setContextTypeSq(const int contextType)
{
  mContextType = ContextType(contextType);
}

 /*----------------------------------------------------------------------*/

inline int Context::getContextTypeSq()
{
  return mContextType;
}

 /*----------------------------------------------------------------------*/
