
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMException_impl.h
/// Contains header implementation of class Exception

 //
 // Constructors & destructor
 //

inline Exception::Exception(const ExceptionType & type, const std::string & description,
			 const std::string & fileName, const std::string & functionName,
			 const u32 & lineNumber)
// You have to initialize the following attributes:
// - mType
// - mDescription
// - mFileName
// - mFunctionName
// - mLineNumber
// - mLastException
{
  mType = type;
  mDescription = description;
  mFileName = fileName;
  mFunctionName = functionName;
  mLineNumber = lineNumber;
  mLastException = this;
}

 /*----------------------------------------------------------------------*/

 //
 // Getters & setters
 //

inline const Exception::ExceptionType & Exception::getType() const
{
  return mType;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Exception::getDescription() const
{
  return mDescription;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Exception::getFileName() const
{
  return mFileName;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Exception::getFunctionName() const
{
  return mFunctionName;
}

 /*-------------------------------------------------------------------------*/

inline const u32 & Exception::getLineNumber() const
{
  return mLineNumber;
}

 /*-------------------------------------------------------------------------*/

inline Exception *Exception::getLastException()
{
  return mLastException;
}

 /*-------------------------------------------------------------------------*/
