
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMFileSystemManager_impl.h
/// Contains header implementation of class FileSystemManager

 //
 // Getters & setters
 //

inline const bool & FileSystemManager::getInitialized() const
{
  return mInitialized;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & FileSystemManager::getAppDirectory() const
{
  return mAppDirectory;
}

 /*-------------------------------------------------------------------------*/

inline void FileSystemManager::setAppDirectory(const std::string & appdirectory)
{
  mAppDirectory = appdirectory;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & FileSystemManager::getDataDirectory() const
{
  return mDataDirectory;
}

 /*-------------------------------------------------------------------------*/

inline void FileSystemManager::setDataDirectory(const std::string & datadirectory)
{
  mDataDirectory = datadirectory;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & FileSystemManager::getHomeDirectory() const
{
  return mHomeDirectory;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & FileSystemManager::getCurrentDirectory() const
{
  return mCurrentDirectory;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & FileSystemManager::getIniFile() const
{
  return mIniFile;
}

 /*-------------------------------------------------------------------------*/
