
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMHostInfo_impl.h
/// Contains header implementation of class HostInfo

 //
 // Getters & setters
 //

inline Container < CPU,
 Mutex >::Pointer & HostInfo::getCPUs()
{
  return mCPUs;
}

 /*-------------------------------------------------------------------------*/

inline Container < GPU,
Mutex >::Pointer & HostInfo::getGPUs()
{
  return mGPUs;
}

 /*-------------------------------------------------------------------------*/

inline Container < HostInfo::NetIDName,
DummyLock >::Pointer & HostInfo::getNetIDNames()
{
  return mNetIDNames;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & HostInfo::getPCLibVersion() const
{
  return mPCLibVersion;
}

 /*-------------------------------------------------------------------------*/

inline const PCint & HostInfo::getPCNumNetworks() const
{
  return mPCNumNetworks;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & HostInfo::getPCVendor() const
{
  return mPCVendor;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & HostInfo::getPCExtensions() const
{
  return mPCExtensions;
}

 /*-------------------------------------------------------------------------*/

inline const PCint & HostInfo::getVolatileFrameletLimit() const
{
  return mVolatileFrameletLimit;
}

 /*-------------------------------------------------------------------------*/

inline const PCint & HostInfo::getRetainOutputLimit() const
{
  return mRetainOutputLimit;
}

 /*-------------------------------------------------------------------------*/
