
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMHost_impl.h
/// Contains header implementation of class Host

 //
 // Getters & setters
 //

inline const bool & Host::getWait() const
{
  return mWait;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Host::getName() const
{
  return mName;
}

 /*-------------------------------------------------------------------------*/

inline void Host::setName(const std::string & name)
{
  mName = name;
}

 /*-------------------------------------------------------------------------*/

inline const std::string & Host::getLowLevelScript() const
{
  return mLowLevelScript;
}

 /*-------------------------------------------------------------------------*/

inline void Host::setLowLevelScript(const std::string & lowlevelscript)
{
  mLowLevelScript = lowlevelscript;
}

 /*-------------------------------------------------------------------------*/

inline Container < Node,
Mutex >::Pointer & Host::getNodes()
{
  return mNodes;
}

 /*-------------------------------------------------------------------------*/

inline const bool & Host::getInitialized() const
{
  return mInitialized;
}

 /*-------------------------------------------------------------------------*/

inline OutputNode::Pointer & Host::getOutputDocument()
{
  return mOutputDocument;
}

 /*-------------------------------------------------------------------------*/

inline const PCid & Host::getSessionID() const
{
  return mSessionID;
}

 /*-------------------------------------------------------------------------*/

inline NetClient *Host::getNetClient() const
{
  return mNetClient;
}

 /*-------------------------------------------------------------------------*/

inline void Host::setNetClient(const NetClient * netclient)
{
  mNetClient = (NetClient *) netclient;
}

 /*-------------------------------------------------------------------------*/

inline const Host::IntPointer & Host::getEndProcessCount() const
{
  return mEndProcessCount;
}

 /*-------------------------------------------------------------------------*/

inline void Host::setEndProcessCount(const Host::IntPointer & endprocesscount)
{
  mEndProcessCount = endprocesscount;
}

 /*-------------------------------------------------------------------------*/

inline const int &Host::getProcessCount() const
{
  return mProcessCount;
}

 /*-------------------------------------------------------------------------*/

inline const int &Host::getID() const
{
  return mID;
}

 /*-------------------------------------------------------------------------*/

inline void Host::setID(const int &id)
{
  mID = id;
}

 /*-------------------------------------------------------------------------*/

inline const Real & Host::getMessageSendingTime() const
{
  return mMessageSendingTime;
}

 /*-------------------------------------------------------------------------*/

inline void Host::setMessageSendingTime(const Real & messagesendingtime)
{
  mMessageSendingTime = messagesendingtime;
}

 /*-------------------------------------------------------------------------*/
