
//
// This source file is a part of ParCompMark
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006  IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

/// @file PCMPremeditations.h
/// Contains common settings for all classes.

//
// Note: All class headers include this header file.
//       You can place common settings here.
//       This file is generated only once at the first `make code' command.
//

#ifndef __PCM_PREMEDITATIONS_H__
#define __PCM_PREMEDITATIONS_H__

// Include project configuration
#include "PCMConfig.h"

// Place any common settings here! ( which can not be descripted in Project.xml )
# include <asm/types.h>
namespace ParCompMark {
    /// Unsigned 8-bit type
    typedef __u8 u8;
    /// Signed 8-bit type
    typedef __s8 s8;
    /// Unsigned 16-bit type
    typedef __u16 u16;
    /// Signed 16-bit type
    typedef __s16 s16;
    /// Unsigned 32-bit type
    typedef __u32 u32;
    /// Signed 32-bit type
    typedef __s32 s32;
    /// Unsigned 64-bit type
    typedef __u64 u64;
    /// Signed 64-bit type
    typedef __s64 s64;

    /// Unsigned floating type
    typedef double Real;
}

// Squirrel C++ binder constant type support
#define SQPLUS_CONST_OPT

// Include declaration of all classes of the project
// ( Needed by pointer definition )
#include "PCMClasses.h"

#endif

