
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef __PCM_SCRIPTREGISTRATION_H__
#  define __PCM_SCRIPTREGISTRATION_H__

/// @file PCMScriptRegistration.h
/// This file contains script class registration method(s) for C++ script binding.
///

/// There are bindings for the following classes:
/// <ul>
///  <li>Application</li>
///  <li>Host</li>
///  <li>Buffer</li>
///  <li>Context</li>
///  <li>Node</li>
///  <li>Process</li>
///  <li>Timer</li>
///  <li>OpenGLRenderingEngine</li>
///  <li>FileSystemManager</li>
///  <li>Renderer</li>
/// </ul>

#  include "PCMApplication.h"
#  include "PCMHost.h"
#  include "PCMBuffer.h"
#  include "PCMContext.h"
#  include "PCMNode.h"
#  include "PCMProcess.h"
#  include "PCMTimer.h"
#  include "PCMOpenGLRenderingEngine.h"
#  include "PCMFileSystemManager.h"
#  include "PCMRenderer.h"

namespace ParCompMark
{

  //
  // Squirrel bindings
  //

/**
 Call static squirrelGlue methods of the binded classes.
 */
  void squirrelClassBindings()
  {
	Application::squirrelGlue();
	Host::squirrelGlue();
	Buffer::squirrelGlue();
	Context::squirrelGlue();
	Node::squirrelGlue();
	Process::squirrelGlue();
	Timer::squirrelGlue();
	OpenGLRenderingEngine::squirrelGlue();
	FileSystemManager::squirrelGlue();
	Renderer::squirrelGlue();
  }

}

#endif
