
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file PCMXDisplay_impl.h
/// Contains header implementation of class XDisplay

 //
 // Getters & setters
 //

inline const std::string & XDisplay::getDisplayName() const
{
  return mDisplayName;
}

 /*-------------------------------------------------------------------------*/

inline::Display * XDisplay::getDisplay()const
{
  return mDisplay;
}

 /*-------------------------------------------------------------------------*/

inline const bool & XDisplay::getInitialized() const
{
  return mInitialized;
}

 /*-------------------------------------------------------------------------*/

inline const bool & XDisplay::getXMTInitialized()
{
  return mXMTInitialized;
}

 /*-------------------------------------------------------------------------*/

inline const bool & XDisplay::getXMTSupported()
{
  return mXMTSupported;
}

 /*-------------------------------------------------------------------------*/

inline const u32 & XDisplay::getWidth() const
{
  return mWidth;
}

 /*-------------------------------------------------------------------------*/

inline const u32 & XDisplay::getHeight() const
{
  return mHeight;
}

 /*-------------------------------------------------------------------------*/

inline const Mutex & XDisplay::getErrorHandlerMutex()
{
  return mErrorHandlerMutex;
}

 /*-------------------------------------------------------------------------*/

inline const bool & XDisplay::getTolerateErrors()
{
  return mTolerateErrors;
}

 /*-------------------------------------------------------------------------*/

inline void XDisplay::setTolerateErrors(const bool & tolerateerrors)
{
  mTolerateErrors = tolerateerrors;
}

 /*-------------------------------------------------------------------------*/
