
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file ParCompMark.h
/// This is the main header of project ParCompMark v0.6.

#ifndef __PARCOMPMARK_H__
#  define __PARCOMPMARK_H__

// Information about the project
/// @mainpage ParCompMark API Reference
/// @par
/// This is the complete API reference for ParCompMark; contained within are the specifications for each 
/// class and the methods on those classes which you can refer to when writing code which uses ParCompMark.

/// @par
/// If you meet ParCompMark for the first time, we recomend you to start with the manual and FAQ. If you are
/// more experienced, and have further questions about the operation of ParCompMark use this API reference.
/// If you find any bugs, please write it to http://amon.ik.bme.hu/parcompmark/bugs . Thank you!

/// @version 0.6
/// @author Prof. Laszlo Szirmay-Kalos
/// @author Balazs Domonkos
/// @author Attila Egri
/// @author Tibor Foris

// Classes of the project
#  include "PCMNetwork.h"
#  include "PCMThread.h"
#  include "PCMApplication.h"
#  include "PCMLogger.h"
#  include "PCMException.h"
#  include "PCMSingleton.h"
#  include "PCMPointer.h"
#  include "PCMLock.h"
#  include "PCMDummyLock.h"
#  include "PCMMutex.h"
#  include "PCMHandleClient.h"
#  include "PCMCluster.h"
#  include "PCMHost.h"
#  include "PCMName.h"
#  include "PCMDynLoad.h"
#  include "PCMBuffer.h"
#  include "PCMContext.h"
#  include "PCMNode.h"
#  include "PCMProcess.h"
#  include "PCMGLXGLContext.h"
#  include "PCMGLXRenderWindow.h"
#  include "PCMXDisplay.h"
#  include "PCMSqVM.h"
#  include "PCMOutputNode.h"
#  include "PCMContainer.h"
#  include "PCMTimer.h"
#  include "PCMHostInfo.h"
#  include "PCMOpenGLRenderingEngine.h"
#  include "PCMFileSystemManager.h"
#  include "PCMCPU.h"
#  include "PCMGPU.h"
#  include "PCMStringConverter.h"
#  include "PCMConfigOptions.h"
#  include "PCMNetServer.h"
#  include "PCMNetClient.h"
#  include "PCMClient.h"
#  include "PCMPluginManager.h"
#  include "PCMPlugin.h"
#  include "PCMRendererPlugin.h"
#  include "PCMRenderer.h"
#  include "PCMOpenGLExtensionLoader.h"
#  include "PCMPCWrapper.h"

#endif
