
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// Inner includes
//

#include "../include/PCMCluster.h"

#include <tinyxml/tinyxml.h>

namespace ParCompMark
{

  template <> Cluster * Singleton < Cluster >::mInstance = 0;
  //
  // Constructors & destructor
  //

  Cluster::Cluster()
	// You have to initialize the following attributes:
	// - mHosts
	// - mClusterDescription
  {
	mHosts = new Container < HostInfo, Mutex >;

  }

 /*----------------------------------------------------------------------*/

  Cluster::~Cluster()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Class methods
  //

  Cluster *Cluster::parseXML(const std::string & strXml)
  {
	TiXmlDocument tiDocument;

	tiDocument.Parse(strXml.c_str());

	//The root element here is of Cluster type
	TiXmlElement *tiCluster = tiDocument.RootElement();

	Cluster *myCluster = new Cluster();

	//First parameter belonging to Cluster: most probably of HostInfo type
	TiXmlElement *tiParam = tiCluster->FirstChildElement();

	for(; tiParam != NULL; tiParam = tiParam->NextSiblingElement())
	{

	 if(false)
	 {
		//TODO: save cluster information in class variables
	 } else
	 {
		//processing xml part containing HOSTINFO information

		HostInfo::Pointer currentHI = HostInfo::parseXML(tiParam);

		if(currentHI.isNotNull())
		{
		 myCluster->mHosts->add(currentHI->getName(), currentHI);
		}

	 }
	}

	return myCluster;
  }

 /*----------------------------------------------------------------------*/

  //
  // Methods
  //

  void Cluster::refreshData()
  {
	// Remove prevous data
	if(mClusterDescription.isNotNull())
	 mClusterDescription.kill();

	mClusterDescription = new OutputNode("cluster", OutputNode::INFORMATION);
	for(Container < HostInfo, Mutex >::Iterator i = mHosts->begin(); i != mHosts->end(); i++)
	{
	 // TODO: not work
	 //mClusterDescription->createChildNode(i->second->serialize2XML());
	}
  }

 /*----------------------------------------------------------------------*/

  std::string Cluster::serialize2Squirrel()
  {
	// TODO: test version, be more specific
	std::ostringstream osstr;
	osstr << "{" << std::endl;

	// Retrieve hosts
	osstr << "hosts = [" << std::endl;
	for(Container < HostInfo, Mutex >::Iterator i = mHosts->begin(); i != mHosts->end(); i++)
	{
	 osstr << "{" << std::endl;
	 osstr << "address = \"" << i->first << '\"' << std::endl;
	 osstr << "}" << std::endl;
	}
	osstr << "]" << std::endl;

	osstr << "}" << std::endl;

	return osstr.str();
  }

 /*----------------------------------------------------------------------*/

  std::string Cluster::serialize2XML()
  {
	refreshData();

	return mClusterDescription->serialize2XML();
  }

 /*----------------------------------------------------------------------*/

}
