
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// Inner includes
//

#include "../include/PCMException.h"

namespace ParCompMark
{

  //
  // Class variables
  //

  Exception *Exception::mLastException = 0;

  //
  // Class methods
  //

   std::string Exception::translateType(const Exception::ExceptionType & type)
  {

	switch (type)
	{
	 case INTERNAL_ERROR:
		return std::string("Unknown internal error");
		break;
		case NULL_POINTER_ERROR:return std::string("Nullpointer error");
		break;
		case INVALID_NAME_ERROR:return std::string("Invalid name error");
		break;
		case INVALID_ENUM_ERROR:return std::string("Invalid enumerated value error");
		break;
		case INVALID_VALUE_ERROR:return std::string("Invalid value error");
		break;
		case INVALID_OBJECT_ERROR:return std::string("Invalid object error");
		break;
		case INVALID_CLASS_ERROR:return std::string("Invalid class error (not proper derived class)");
		break;
		case INVALID_OPERATION_ERROR:return std::string("Invalid operation error");
		break;
		case OPERATION_NOT_SUPPORTED_ERROR:return std::string("Operation is not supported on this platform");
		break;
		case OUT_OF_MEMORY_ERROR:return std::string("Out of memory error");
		break;
		case FILE_IO_ERROR:return std::string("File I/O error");
		break;
		case FILE_FORMAT_ERROR:return std::string("Invalid file format error");
		break;
		case USER_BREAK_ERROR:return std::string("The user stopped the application");
		break;
		case SCRIPT_ERROR:return std::string("Error in a script file.");
		break;
		case XLIB_ERROR:return std::string("Xlib error.");
		break;
	}

	return std::string("Unknown exception");

  }

 /*----------------------------------------------------------------------*/

}
