
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// Inner includes
//

#include "../include/PCMHandleClient.h"

#include "../include/PCMNetServer.h"

#include "../include/PCMOutputNode.h"

namespace ParCompMark
{

  //
  // Constructors & destructor
  //

  HandleClient::HandleClient(const NetServer * net):
	// Parent initializer 
  Client("HandleClient thread"	/* Name of the thread. */
	)
  {
	mParent = (NetServer *) net;
	mInitialized = false;

	initialize();
  }

 /*----------------------------------------------------------------------*/

  HandleClient::~HandleClient()
  {

	if(mInitialized)
	{
	 finalize();
	}

  }

 /*----------------------------------------------------------------------*/

  //
  // Methods
  //

  void HandleClient::initialize()
  {
	Assert(!mInitialized, INVALID_OPERATION_ERROR, "HandleClient::initialize()");

	mInitialized = true;
  }

 /*----------------------------------------------------------------------*/

  void HandleClient::finalize()
  {
	Assert(mInitialized, INVALID_OPERATION_ERROR, "HandleClient::finalize()");

	if(mStreamSocket != -1)
	{
	 close(mStreamSocket);
	 mStreamSocket = -1;
	}

	mInitialized = false;
  }

 /*----------------------------------------------------------------------*/

  void HandleClient::openConnection()
  {
	Assert(mStreamSocket != -1, INVALID_OPERATION_ERROR, "HandleClient::task()");

	return;
  }

 /*----------------------------------------------------------------------*/

  void HandleClient::task()
  {
	Assert(mStreamSocket != -1, INVALID_OPERATION_ERROR, "HandleClient::task()");

	recieveMessage();

	handleMessage();

	NetServer::IntPointer p = ((NetServer *) mParent)->getRecievedNumber();

	p.lock();

	(*p.getPtr())++;

	if(*p.getPtr() == ((NetServer *) mParent)->getHostNumber())
	{
	 ((NetServer *) mParent)->go();
	}

	p.unlock();

	delete this;

  }

 /*----------------------------------------------------------------------*/

}
