
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

//
// Inner includes
//

#include "../include/PCMPCWrapper.h"

namespace ParCompMark
{

  //
  // Class methods
  //

  PCerr PCWrapper::contextCreate(PCid netId, PCstring thisHost, PCcontext * ctx)
  {
	return pcContextCreate(netId, thisHost, ctx);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::contextCreateMaster(const PCint * properties, PCstring * hosts, PCstring thisHost,
					 PCcontext * ctx)
  {
	return pcContextCreateMaster(properties, hosts, thisHost, ctx);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::contextDestroy(PCcontext ctx)
  {
	return pcContextDestroy(ctx);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::contextGetInteger(PCcontext ctx, PCenum property, PCint hostIndex, PCint * value)
  {
	return pcContextGetInteger(ctx, property, hostIndex, value);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::contextSetInteger(PCcontext ctx, PCenum property, PCint hostIndex, PCint value)
  {
	return pcContextSetInteger(ctx, property, hostIndex, value);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::contextSync(PCcontext ctx)
  {
	return pcContextSync(ctx);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::frameAddFramelet(PCcontext ctx, PCid frameId, PCvoidp color, PCvoidp depth)
  {
	return pcFrameAddFramelet(ctx, frameId, color, depth);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::frameAddGLFrameletEXT(PCcontext ctx, PCid frameId, PCint xOffset, PCint yOffset)
  {
	return pcFrameAddGLFrameletEXT(ctx, frameId, xOffset, yOffset);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::frameBegin(PCcontext ctx, PCid * frameId, PCuint numFramelets, PCuint * xOffset, PCuint * yOffset,
				PCuint * width, PCuint * height, PCuint sortorder)
  {
	return pcFrameBegin(ctx, frameId, numFramelets, xOffset, yOffset, width, height, &sortorder);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::frameEnd(const PCcontext ctx, const PCid frameId)
  {
	return pcFrameEnd(ctx, frameId);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::frameResultChannel(PCcontext ctx, PCid frameId, PCuint xOffset, PCuint yOffset, PCuint width,
					PCuint height, PCuint channelType, PCchannel channel)
  {
	return pcFrameResultChannel(ctx, frameId, xOffset, yOffset, width, height, channelType, &channel);
  }

 /*----------------------------------------------------------------------*/

  PCstring PCWrapper::getErrorString(PCerr error)
  {
	return pcGetErrorString(error);
  }

 /*----------------------------------------------------------------------*/

  PCint PCWrapper::queryExtension(PCstring extensionName)
  {
	return pcQueryExtension(extensionName);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::sessionCreate(PCid sessionId)
  {
	return pcSessionCreate(sessionId);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::sessionDestroy()
  {
	return pcSessionDestroy();
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::systemGetInteger(PCenum property, PCint qualifier, PCint * value)
  {
	return pcSystemGetInteger(property, qualifier, value);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::systemFinalize()
  {
	return 0;		//pcSystemFinalize();
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::systemGetString(PCenum property, PCint qualifier, PCstring * value)
  {
	return pcSystemGetString(property, qualifier, value);
  }

 /*----------------------------------------------------------------------*/

  PCerr PCWrapper::systemInitialize(const PCstring searchPath)
  {
	return pcSystemInitialize(searchPath);
  }

 /*----------------------------------------------------------------------*/

}
