
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestCluster.h
/// Test case declaration for class Cluster.

#ifndef __TEST_CLUSTER_H__
#  define __TEST_CLUSTER_H__

//
// CppUnit include
//
#  include <cppunit/extensions/HelperMacros.h>

//
// Tested class include
//
#  define PARCOMPMARK_TEST
#  include "../../include/PCMCluster.h"
#  undef PARCOMPMARK_TEST

//
// Opening namespace of the tested project
//
using namespace ParCompMark;

namespace ParCompMarkTest
{

  /**
	Test suite for ParCompMark::Cluster. This is a <a href="http://cppunit.sourceforge.net/">CppUnit</a> 
	test suite for class ParCompMark::Cluster of project ParCompMark.
   */

  class TestCluster:public CppUnit::TestFixture
  {

	// First, we declare the suite, passing the class name to the macro:
	/// \skip CPPUNIT_TEST_SUITE
	CPPUNIT_TEST_SUITE(TestCluster);

	// Then, we declare each test case of the fixture:
	/// \skip CPPUNIT_TEST
	CPPUNIT_TEST(test_constructor);
	CPPUNIT_TEST(test_destructor);
	CPPUNIT_TEST(test_refreshData);
	CPPUNIT_TEST(test_serialize2Squirrel);
	CPPUNIT_TEST(test_serialize2XML);
	CPPUNIT_TEST(test_parseXML_cstd__string);

	// Finally, we end the suite declaration:
	/// \skip CPPUNIT_TEST_SUITE_END
	CPPUNIT_TEST_SUITE_END();

   public:

  /** Sets up context before running a test. */
	void setUp();

  /** Cleans up after the test run. */
	void tearDown();

   protected:

	//
	// Constructor & destructor tests
	//

	/** 
	 Tests constructor Cluster::Cluster().
	 */
	void test_constructor();

	/** 
	 Tests destructor Cluster::~Cluster().
	 */
	void test_destructor();

	//
	// Class method tests
	//

	/** 
	 Tests method Cluster::parseXML(const std::string &strXml).
	 */
	void test_parseXML_cstd__string();

	//
	// Method tests
	//

	/** 
	 Tests method Cluster::refreshData().
	 */
	void test_refreshData();

	/** 
	 Tests method Cluster::serialize2Squirrel().
	 */
	void test_serialize2Squirrel();

	/** 
	 Tests method Cluster::serialize2XML().
	 */
	void test_serialize2XML();

  };

}

#endif
