
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestNetServer.h
/// Test case declaration for class NetServer.

#ifndef __TEST_NETSERVER_H__
#  define __TEST_NETSERVER_H__

//
// CppUnit include
//
#  include <cppunit/extensions/HelperMacros.h>

//
// Tested class include
//
#  define PARCOMPMARK_TEST
#  include "../../include/PCMNetServer.h"
#  undef PARCOMPMARK_TEST

//
// Opening namespace of the tested project
//
using namespace ParCompMark;

namespace ParCompMarkTest
{

  /**
	Test suite for ParCompMark::NetServer. This is a <a href="http://cppunit.sourceforge.net/">CppUnit</a> 
	test suite for class ParCompMark::NetServer of project ParCompMark.
   */

  class TestNetServer:public CppUnit::TestFixture
  {

	// First, we declare the suite, passing the class name to the macro:
	/// \skip CPPUNIT_TEST_SUITE
	CPPUNIT_TEST_SUITE(TestNetServer);

	// Then, we declare each test case of the fixture:
	/// \skip CPPUNIT_TEST
	CPPUNIT_TEST(test_constructor_cstd__string);
	CPPUNIT_TEST(test_destructor);
	CPPUNIT_TEST(test_initialize);
	CPPUNIT_TEST(test_finalize);
	CPPUNIT_TEST(test_sendBroadcastMessage_cstd__string_cstd__string);
	CPPUNIT_TEST(test_buildCluster);
	CPPUNIT_TEST(test_task);

	// Finally, we end the suite declaration:
	/// \skip CPPUNIT_TEST_SUITE_END
	CPPUNIT_TEST_SUITE_END();

   public:

  /** Sets up context before running a test. */
	void setUp();

  /** Cleans up after the test run. */
	void tearDown();

   protected:

	//
	// Constructor & destructor tests
	//

	/** 
	 Tests constructor NetServer::NetServer(const std::string &name).
	 */
	void test_constructor_cstd__string();

	/** 
	 Tests destructor NetServer::~NetServer().
	 */
	void test_destructor();

	//
	// Method tests
	//

	/** 
	 Tests method NetServer::initialize().
	 */
	void test_initialize();

	/** 
	 Tests method NetServer::finalize().
	 */
	void test_finalize();

	/** 
	 Tests method NetServer::sendBroadcastMessage(const std::string &type, const std::string &message).
	 */
	void test_sendBroadcastMessage_cstd__string_cstd__string();

	/** 
	 Tests method NetServer::buildCluster().
	 */
	void test_buildCluster();

	/** 
	 Tests method NetServer::task().
	 */
	void test_task();

  };

}

#endif
