
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestOpenGLExtensionLoader.h
/// Test case declaration for class OpenGLExtensionLoader.

#ifndef __TEST_OPENGLEXTENSIONLOADER_H__
#  define __TEST_OPENGLEXTENSIONLOADER_H__

//
// CppUnit include
//
#  include <cppunit/extensions/HelperMacros.h>

//
// Tested class include
//
#  define PARCOMPMARK_TEST
#  include "../../include/PCMOpenGLExtensionLoader.h"
#  undef PARCOMPMARK_TEST

//
// Opening namespace of the tested project
//
using namespace ParCompMark;

namespace ParCompMarkTest
{

  /**
	Test suite for ParCompMark::OpenGLExtensionLoader. This is a <a href="http://cppunit.sourceforge.net/">CppUnit</a> 
	test suite for class ParCompMark::OpenGLExtensionLoader of project ParCompMark.
   */

  class TestOpenGLExtensionLoader:public CppUnit::TestFixture
  {

	// First, we declare the suite, passing the class name to the macro:
	/// \skip CPPUNIT_TEST_SUITE
	CPPUNIT_TEST_SUITE(TestOpenGLExtensionLoader);

	// Then, we declare each test case of the fixture:
	/// \skip CPPUNIT_TEST
	CPPUNIT_TEST(test_load_cstd__list___std__string__);
	CPPUNIT_TEST(test_loadDelayed);
	CPPUNIT_TEST(test__load_cstd__list___std__string__);
	CPPUNIT_TEST(test__init);

	// Finally, we end the suite declaration:
	/// \skip CPPUNIT_TEST_SUITE_END
	CPPUNIT_TEST_SUITE_END();

   public:

  /** Sets up context before running a test. */
	void setUp();

  /** Cleans up after the test run. */
	void tearDown();

   protected:

	//
	// Class method tests
	//

	/** 
	 Tests method OpenGLExtensionLoader::load(const std::list < std::string > &extensions).
	 */
	void test_load_cstd__list___std__string__();

	/** 
	 Tests method OpenGLExtensionLoader::loadDelayed().
	 */
	void test_loadDelayed();

	/** 
	 Tests method OpenGLExtensionLoader::_load(const std::list < std::string > &extensions).
	 */
	void test__load_cstd__list___std__string__();

	/** 
	 Tests method OpenGLExtensionLoader::_init().
	 */
	void test__init();

  };

}

#endif
