
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestApplication.cpp
/// Test case implementation for class Application.

#include "../include/TestApplication.h"

namespace ParCompMarkTest
{

  void TestApplication::setUp()
  {
	std::string currentLogFile = "logs/TestApplication.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestApplication::test_constructor()
  {
	/*
	 * Application *pApp = 0;
	 * 
	 * CPPUNIT_ASSERT_NO_THROW(pApp = new Application());
	 * 
	 * // Logger is alive
	 * CPPUNIT_ASSERT(pApp->mLogger.isNotNull());
	 */
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_destructor()
  {
	// TODO this test confuses the logger
	//Application *pApp;
	//CPPUNIT_ASSERT_NO_THROW(pApp = new Application());

	//CPPUNIT_ASSERT_NO_THROW(delete pApp);
  }

 /*----------------------------------------------------------------------*/

  //
  // Class method tests
  //

  void TestApplication::test_complement_int_int()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Complement command line commands.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_parseCommandLine_cu32_cchar_pp()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Parse ANSI C command line.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_showHelp_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Write help to std out.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_showVersion_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Write version to std out.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setCommanderOn_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set commander mode.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setGUIOn_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set GUI mode.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setLowLevelOn_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set low-level scripting mode.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setLowLevelScriptFile_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set low-level script file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setDynamicScriptFile_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set dynamic script file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setScenarioScriptFile_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set scenario script file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setCluster_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set cluster description file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setParameters_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set parameters description file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setInput_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set input file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setOutput_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set output file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setExpectedHostCount_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set expected number of rendering hosts.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setUserInterface_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set user the type of interface.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_hasEnvironmentVariable_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Returns true if specified environment variable exists.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_getEnvironmentVariable_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Get environment variable.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_terminateHandler()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Abnormal termination handler.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_terminateHandlerNOP()
  {

	/*
	 * You have to verify the following:
	 * 
	 * No operation termination handler. The terminateHandler() method sets this method as Abnormal termination handler during its run.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_unexpectedHandler()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Unexpected exception handler.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_segfaultHandler_int()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Segmentation fault handler.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_interruptHandler_int()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Interrupt signal handler.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_getInstance()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Gets the instance of the singleton class. Reimplemented for squirrel usage.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestApplication::test_setupHandlers()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Setup special event handlers.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_initialize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Initialize the PCM application.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_finalize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Finalize the PCM application.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_finalizeCommander()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Addintional finalization code for commander mode. This method is executed at the beginning of the common finalize() method.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_finalizeSoldier()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Addintional finalization code for soldier mode. This method is executed at the beginning of the common finalize() method.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setFromConfigOptions()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Call application-wide setters on config options.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_createVirtualMachines()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create and initialize virtual machines for dynamic script execution and for user interaction handling.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_startOperation()
  {

	/*
	 * You have to verify the following:
	 * 
	 * The application starts its operation. The operation depends on the
	 * commander mode flag.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_writeOutput()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Write collected output.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_waitForOutput()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Wait until the output is fully written.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_quit()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Quit from application.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_compileDynamic()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Compile dynamic script.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_start()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Start compositing.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_stop()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Stop compositing.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_autoDetection()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Auto detection of the cluster.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_cleanup()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Do cleanup. Empty output document etc.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_getHostListForSquirrel()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return the list of hosts in cluster as a Squirrel string array.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_getLowLevelScriptForSquirrel()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return the low-level script as a string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_getDynamicScriptForSquirrel()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return the dynamic script as a string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_hasDynamicScript()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return true if a dynamic script is loaded.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_hasScenarioScript()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return true if a scenario script is loaded.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_getDynamicScriptParametersForSquirrel()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return the list of dynamic script parameters as a Squirrel string array.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_getProgramInfo()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return one line program info as a string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_calculateMessageSendTime()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Calcualtes the message sendign time.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test__pseudoStop()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Handle pseudoSTOP post command.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_commanderOperation()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Operation of a commander mode application.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_soldierOperation()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Operation of a soldier mode (not commander mode) application.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_textUserInterface()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Start textual user interface.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_noUserInterface()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Start "no" user interface.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_executeUserCommand_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Executes a single line user command. User command can be a Squirrel code fragment or an abrevation.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_processSquirrelCommandList()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Executes the commands in the squirrel command list.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_doPostCommand()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Executes current post command task.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_loadLowLevelScript_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Load low-level script from the specified filename.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_loadDynamicScript_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Load dynamic script from the specified filename.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_loadScenarioScript_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Load scenario script from the specified filename.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_pushSquirrelCommand_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Push a command into the Squirrel command list.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_createLowLevelScript_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create low-level script from dynamic script and cluster description.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_processScenarioScript()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Process scenario script file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_setEnvironmentVariablesToSquirrel()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set environment variables to the Squirrel.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_initializeDynamicScriptParameters_cbool()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Compile dynamic script and initialize dynamic script parameters in reset or complement mode.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test_retrieveDynamicScriptParameters()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Retrieve dynamic script parameters from the loaded dynamic script.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test__loadScenario()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Handle LOADSCENARIO post command.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test__loadDynamic()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Handle LOADDYNAMIC post command.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test__compileDynamic()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Handle COMPILEDYNAMIC post command.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test__start()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Handle START post command.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test__stop()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Handle STOP post command.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestApplication::test__quit()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Handle QUIT post command.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestApplication);
}
