
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestBuffer.cpp
/// Test case implementation for class Buffer.

#include "../include/TestBuffer.h"
#include "../../include/PCMFileSystemManager.h"

namespace ParCompMarkTest
{

  void TestBuffer::setUp()
  {
	std::string currentLogFile = "logs/TestBuffer.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestBuffer::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestBuffer::test_constructor()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Default constructor for Squirrel compatibility. Calling this constructor always raises an exception.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestBuffer::test_constructor_cPCuint_cPCuint_cPCuint_cPCuint_cPCuint_Node_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create a buffer by initializing its parameters.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestBuffer::test_destructor()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestBuffer::test_initialize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Initialize the buffer.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestBuffer::test_finalize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Finalize the buffer.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestBuffer::test_saveToFile_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Save the image in the buffer to the specified file.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestBuffer::test_freeBuffers()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Deallocate mColour and mDepth buffers.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestBuffer);
}
