
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestCPU.cpp
/// Test case implementation for class CPU.

#include "../include/TestCPU.h"
//#include "tinyxml/tinyxml.h"

namespace ParCompMarkTest
{

  void TestCPU::setUp()
  {

	std::string currentLogFile = "logs/TestCPU.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}

  }

 /*----------------------------------------------------------------------*/

  void TestCPU::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestCPU::test_constructor_cstd__string_cOutputNode__NodeType()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Creates CPU node.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestCPU::test_destructor()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Class method tests
  //

  void TestCPU::test_parseXML_TiXmlElement_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Creates a CPU class instance based on xml
	 */

	//TODO: test with other CPU with more parameters

	std::
	 string
	 xml
	 ("<info:CPU id=\"0\"><info:param name=\"vendor-id\" value=\"GenuineIntel\"/><info:param name=\"flags\" value=\"fpu vme de pse tsc msr pae mce cx8 apic sep mtrr pge mca cmov pat pse36 clflush dts acpi mmx fxsr sse sse2 ss ht tm pbe pni monitor ds_cpl cid xtpr\"/><info:param name=\"bogomips\" value=\"6002.94\"/></info:CPU>");

	TiXmlDocument tiDocument;

	tiDocument.Parse(xml.c_str());

	TiXmlElement *tiCPU = tiDocument.RootElement();

	CPU::Pointer myCPU = CPU::parseXML(tiCPU);

	CPPUNIT_ASSERT(myCPU->mVendor.compare("GenuineIntel") == 0);
	CPPUNIT_ASSERT(myCPU->mFlags.
		   compare
		   ("fpu vme de pse tsc msr pae mce cx8 apic sep mtrr pge mca cmov pat pse36 clflush dts acpi mmx fxsr sse sse2 ss ht tm pbe pni monitor ds_cpl cid xtpr")
		   == 0);
	CPPUNIT_ASSERT(::fabs(myCPU->mBogomips - 6002.94) < 1e-2);

  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestCPU::test_refreshData()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Refresh CPU datas.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestCPU);
}
