
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestCluster.cpp
/// Test case implementation for class Cluster.

#include "../include/TestCluster.h"
#include "../../include/PCMFileSystemManager.h"
#include "tinyxml/tinyxml.h"

namespace ParCompMarkTest
{

  void TestCluster::setUp()
  {
	std::string currentLogFile = "logs/TestCluster.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestCluster::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestCluster::test_constructor()
  {

	Cluster *c;

	CPPUNIT_ASSERT_NO_THROW(c = new Cluster());

  }

 /*----------------------------------------------------------------------*/

  void TestCluster::test_destructor()
  {

	//tested in constructor
  }

 /*----------------------------------------------------------------------*/

 /**
 //
 // Method tests
 //

 void TestCluster::test_getHosts()
 {
	Cluster *c;

	CPPUNIT_ASSERT_NO_THROW(c = new Cluster());
	//CPPUNIT_ASSERT_NO_THROW(c->getHosts());
	printf("\ntestNumberElement: %d\n", c->getHosts()->getElementNumber());
 }
 */

 /*----------------------------------------------------------------------*/

  //
  // Class method tests
  //

  void TestCluster::test_parseXML_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Creates a Cluster class instance based on xml
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestCluster::test_refreshData()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Refresh output node data.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestCluster::test_serialize2Squirrel()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Serialize the cluster to Squirrel structure code snipplet.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestCluster::test_serialize2XML()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Serialize the cluster to XML. 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestCluster);
}
