
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestContext.cpp
/// Test case implementation for class Context.

#include "../include/TestContext.h"
#include "../../include/PCMFileSystemManager.h"

namespace ParCompMarkTest
{

  void TestContext::setUp()
  {
	std::string currentLogFile = "logs/TestContext.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestContext::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestContext::test_constructor()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Default constructor for Squirrel compatibility. Calling this constructor always raises an exception.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestContext::test_constructor_Process_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create Context. Normally Process calls this constructor.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestContext::test_destructor()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestContext::test_setProcesses_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create process array from string separated by semicolons.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestContext::test_initialize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Init the PC context.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestContext::test_finalize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Finalize the PC context.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestContext::test_setContextTypeSq_cint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Alternate squirrel setter of mContextType.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestContext::test_getContextTypeSq()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Alternate squirrel setter of mContextType.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestContext);
}
