
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestException.cpp
/// Test case implementation for class Exception.

#include "../include/TestException.h"

namespace ParCompMarkTest
{

  void TestException::setUp()
  {
	// Exception does not need logger directly
  }

 /*----------------------------------------------------------------------*/

  void TestException::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestException::test_constructor_cExceptionType_cstd__string_cstd__string_cstd__string_cu32()
  {
	Exception e(Exception::INTERNAL_ERROR, "This is the description", "This is the filename",
		 "This is the method name", 1234);

	Exception *le = Exception::getLastException();

	CPPUNIT_ASSERT(le->getType() == Exception::INTERNAL_ERROR);
	CPPUNIT_ASSERT(le->getDescription() == "This is the description");
	CPPUNIT_ASSERT(le->getFileName() == "This is the filename");
	CPPUNIT_ASSERT(le->getFunctionName() == "This is the method name");
	CPPUNIT_ASSERT(le->getLineNumber() == 1234);
  }

 /*----------------------------------------------------------------------*/

  //
  // Class method tests
  //

  void TestException::test_translateType_cException__ExceptionType()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Translate type to human readable format.
	 */

	CPPUNIT_ASSERT_NO_THROW(Exception::translateType(Exception::INTERNAL_ERROR));
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestException);
}
