
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestGLXRenderWindow.cpp
/// Test case implementation for class GLXRenderWindow.

#include "../include/TestGLXRenderWindow.h"
#include "../../include/PCMFileSystemManager.h"

namespace ParCompMarkTest
{

  void TestGLXRenderWindow::setUp()
  {
	std::string currentLogFile = "logs/TestGLXRenderWindow.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestGLXRenderWindow:: 
	test_constructor_XDisplay__Pointer_Process_p_cstd__string_cbool_cu32_cu32_cu32_cs32_cs32_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create GLX render window. Normally called by XDisplay::createRenderWindow.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_destructor()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestGLXRenderWindow::test_reposition_cs32_cs32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set new window position.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_resize_cu32_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set new window sizes.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_startFrame()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Start a frame.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_finishFrame()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Finish current frame.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_setCurrent()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Enable the context of the window. 
	 * All subsequent rendering commands will go on this window.
	 * The side effect of calling this method is reseting the window statistics.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_releaseCurrent()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Disable the context of the window. 
	 * Release the current context without assigning a new one.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_initialize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Initialize the GLX RenderWindow. Protected method for internal use.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_finalize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Finalize the GLX RenderWindow. Protected method for internal use.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_resetStatistics()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Reset statistics. It is called internally when initializing the window. But it can be called by some other process to 
	 * get the most accurate window statistics.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_reportTriangles_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Report certain number of triangles being rendered to the render window. 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_createWindow()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create GLX Window. Protected method for internal use.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_destroyWindow()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Destroy GLX Window. Protected method for internal use.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test_updateStatistics()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Update statistics of the window. Protected method for internal use.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test__reposition()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Efficiently set window position (for internal use).
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test__resize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Efficiently set window sizes (for internal use).
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestGLXRenderWindow::test__setCaption()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Efficiently set window caption (for internal use).
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestGLXRenderWindow);
}
