
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestHost.cpp
/// Test case implementation for class Host.

#include "../include/TestHost.h"

namespace ParCompMarkTest
{

  void TestHost::setUp()
  {
	std::string currentLogFile = "logs/TestHost.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestHost::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestHost::test_constructor_cstd__string_NetClient_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Creates a host with a specified name.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_destructor()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Class method tests
  //

  void TestHost::test_getInstance()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Gets the instance of the singleton class. Reimplemented for squirrel usage.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestHost::test_openXDisplay_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Open an X display. An X display can be opened 
	 * several times, and does not have to be closed. The host
	 * will close it when it is destructed. When no parameter is set,
	 * the default display will be opened.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_getFirstXDisplay()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return the first X Display on this host.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_openXDisplays()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Automatically scan available X displays on this host and open them.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_closeXDisplays()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Close all opened X displays.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_initialize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Initialize host from low level script.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_finalize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Finalize the host.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_createNode_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create node on this host.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_start()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Start the nodes.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_stop()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_collectData()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Collect data from nodes.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestHost::test_setFrameID_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set the ending frameID of processes.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestHost);
}
