
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006  IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


/// @file TestMain.cpp
/// Unit testbench application entry point

//
/// @warning This is a fully autogenerated file. Do not edit!
//

// CppUnit includes
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/ui/text/TestRunner.h>
#include <cppunit/CompilerOutputter.h>

//
// Test suite includes
//

#include "../include/TestNetwork.h"
#include "../include/TestThread.h"
#include "../include/TestApplication.h"
#include "../include/TestLogger.h"
#include "../include/TestException.h"
#include "../include/TestSingleton.h"
#include "../include/TestPointer.h"
#include "../include/TestLock.h"
#include "../include/TestDummyLock.h"
#include "../include/TestMutex.h"
#include "../include/TestHandleClient.h"
#include "../include/TestCluster.h"
#include "../include/TestHost.h"
#include "../include/TestName.h"
#include "../include/TestDynLoad.h"
#include "../include/TestBuffer.h"
#include "../include/TestContext.h"
#include "../include/TestNode.h"
#include "../include/TestProcess.h"
#include "../include/TestGLXGLContext.h"
#include "../include/TestGLXRenderWindow.h"
#include "../include/TestXDisplay.h"
#include "../include/TestSqVM.h"
#include "../include/TestOutputNode.h"
#include "../include/TestContainer.h"
#include "../include/TestTimer.h"
#include "../include/TestHostInfo.h"
#include "../include/TestOpenGLRenderingEngine.h"
#include "../include/TestFileSystemManager.h"
#include "../include/TestCPU.h"
#include "../include/TestGPU.h"
#include "../include/TestStringConverter.h"
#include "../include/TestConfigOptions.h"
#include "../include/TestNetServer.h"
#include "../include/TestNetClient.h"
#include "../include/TestClient.h"
#include "../include/TestPluginManager.h"
#include "../include/TestPlugin.h"
#include "../include/TestRendererPlugin.h"
#include "../include/TestRenderer.h"
#include "../include/TestOpenGLExtensionLoader.h"
#include "../include/TestPCWrapper.h"


// Check for QtTestRunner compatibility
#if defined(HAVE_QT3_QAPPLICATION_H) && defined(HAVE_LIBQTTESTRUNNER)
#define WITH_QTTESTRUNNER 1	
#endif
	
#ifdef WITH_QTTESTRUNNER
// Qt and GLX compatibility hack
#undef CursorShape
#undef None
#undef KeyPress
#undef KeyRelease
#undef FocusIn
#undef FocusOut
	
// QtTestRunner includes
#include <qt3/qapplication.h>
#include <cppunit/ui/qt/TestRunner.h>
#endif

using namespace ParCompMarkTest;

/**
	Test runner with textual user interface
 */
int textRunner() {
    CppUnit::TextUi::TestRunner runner;

    // First, we retreive the instance of the TestFactoryRegistry
    CppUnit::TestFactoryRegistry &registry = CppUnit::TestFactoryRegistry::getRegistry();

    // Then, we obtain and add a new TestSuite  created by the
    // TestFactoryRegistry  that contains all the test suite registered
    // using CPPUNIT_TEST_SUITE_REGISTRATION()
    runner.addTest(registry.makeTest());
		
    // Set compiler readable output
    runner.setOutputter( new CppUnit::CompilerOutputter(&runner.result(), std::cout ) );

    // Run the tests
    return runner.run() ? 0 : 1;
}

/**
	Test runner with graphical user interface
 */
#ifdef WITH_QTTESTRUNNER
int guiRunner(int argc, char **argv) {

	// Create Qt application and test runner
	QApplication app(argc, argv);
	CppUnit::QtTestRunner runner;

    // First, we retreive the instance of the TestFactoryRegistry
    CppUnit::TestFactoryRegistry &registry = CppUnit::TestFactoryRegistry::getRegistry();

    // Then, we obtain and add a new TestSuite  created by the
    // TestFactoryRegistry  that contains all the test suite registered
    // using CPPUNIT_TEST_SUITE_REGISTRATION()
    runner.addTest(registry.makeTest());
		
    // Run the tests
    runner.run(true);
    
    return 0;
}
#endif
		
/**
    @remarks
    Runs CppUnit tests.
    
    
    @par
    Tested classes:
    <ul>
    <li> ParCompMark::Network</li>
<li> ParCompMark::Thread</li>
<li> ParCompMark::Application</li>
<li> ParCompMark::Logger</li>
<li> ParCompMark::Exception</li>
<li> ParCompMark::Singleton</li>
<li> ParCompMark::Pointer</li>
<li> ParCompMark::Lock</li>
<li> ParCompMark::DummyLock</li>
<li> ParCompMark::Mutex</li>
<li> ParCompMark::HandleClient</li>
<li> ParCompMark::Cluster</li>
<li> ParCompMark::Host</li>
<li> ParCompMark::Name</li>
<li> ParCompMark::DynLoad</li>
<li> ParCompMark::Buffer</li>
<li> ParCompMark::Context</li>
<li> ParCompMark::Node</li>
<li> ParCompMark::Process</li>
<li> ParCompMark::GLXGLContext</li>
<li> ParCompMark::GLXRenderWindow</li>
<li> ParCompMark::XDisplay</li>
<li> ParCompMark::SqVM</li>
<li> ParCompMark::OutputNode</li>
<li> ParCompMark::Container</li>
<li> ParCompMark::Timer</li>
<li> ParCompMark::HostInfo</li>
<li> ParCompMark::OpenGLRenderingEngine</li>
<li> ParCompMark::FileSystemManager</li>
<li> ParCompMark::CPU</li>
<li> ParCompMark::GPU</li>
<li> ParCompMark::StringConverter</li>
<li> ParCompMark::ConfigOptions</li>
<li> ParCompMark::NetServer</li>
<li> ParCompMark::NetClient</li>
<li> ParCompMark::Client</li>
<li> ParCompMark::PluginManager</li>
<li> ParCompMark::Plugin</li>
<li> ParCompMark::RendererPlugin</li>
<li> ParCompMark::Renderer</li>
<li> ParCompMark::OpenGLExtensionLoader</li>
<li> ParCompMark::PCWrapper</li>
	</ul>
    
*/
int main(int argc, char **argv)
{
#ifdef WITH_QTTESTRUNNER
	// Try to initialize multithreading for QtRunner
	XInitThreads();
	
	if(argc > 1 && !strcmp(argv[1], "--gui"))
		return guiRunner(argc, argv);
	else
#endif
		return textRunner();
}

