
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestNode.cpp
/// Test case implementation for class Node.

#include "../include/TestNode.h"

namespace ParCompMarkTest
{

  void TestNode::setUp()
  {
	std::string currentLogFile = "logs/TestNode.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestNode::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestNode::test_constructor()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Default constructor for Squirrel compatibility. Calling this constructor always raises an exception.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_constructor_cstd__string_Host_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create node. Normally Host calls this constructor.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_destructor()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestNode::test_initialize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Initialize the node.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_finalize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Finalize the node.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_createProcess_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create process on this node.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_createBuffer_cchar_p_cPCuint_cPCuint_cPCuint_cPCuint_cPCuint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create buffer on this node.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_getBuffer_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Get buffer by name.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_start()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Start the processes.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_stop()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Stop the processes.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_collectData()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Collect data from nodes.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestNode::test_setFrameID_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set the ending frameID of processes.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestNode);
}
