
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestOpenGLRenderingEngine.cpp
/// Test case implementation for class OpenGLRenderingEngine.

#include "../include/TestOpenGLRenderingEngine.h"
#include "../../include/PCMFileSystemManager.h"

namespace ParCompMarkTest
{

  void TestOpenGLRenderingEngine::setUp()
  {
	std::string currentLogFile = "logs/TestOldContainer.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestOpenGLRenderingEngine::test_constructor()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Default constructor for Squirrel compatibility. Calling this constructor always raises an exception.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_constructor_Process_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create rendering engine for the specified process.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_destructor()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Class method tests
  //

  void TestOpenGLRenderingEngine::test_create_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create (cast) rendering engine from a pointer passed in a string in '0x000000' format.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestOpenGLRenderingEngine::test_createCustomRenderer_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create custom renderer from a renderer plugin.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_resizeRenderers_cu32_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Resize the canvas of all renderers belongs to this rendering engine. 
	 * The pcmOnResize event handler method of the renderers will be called.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_getSortOrderFromRenderers()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Get alpha sorting order from renderers on this rendering engine. If the corresponding renderer plugin
	 * has pcmOnResize function, it will be called otherwise -1 is returned. Note: -1 is also returned
	 * when the sorting order can not be specified by the plugin.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setAutoRenderOrder_cRenderer_p_cs32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set automatic rendering order for the specified renderer. If Renderer::NOAUTORENDERING is specified as order, the
	 * renderer will be removed from the queue.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_doAutoRendering()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Automatically call render() methods of the custom renderers placed in the queue.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_perspective_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set perspective projection.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_ortho2D_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Define a 2D orthographic projection.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_viewport_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set viewport with window relative coordinates (0.0 .. 1.0).
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_pushModelView()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Push the modelview matrix on the matrix stack.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_popModelView()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Pop the modelview matrix from the matrix stack.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_translate_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Translate the modelview matrix.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_rotate_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Rotate the modelview matrix.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_scale_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Scale the modelview matrix.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setCameraPosition_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set camera position.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setCameraTarget_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set position of camera target.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setCameraUpVector_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set up vector of the camera.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setColor_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set drawing color.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setAmbientMaterial_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set ambient material color.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setDiffuseMaterial_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set diffuse material color.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setSpecularMaterial_cdouble_cdouble_cdouble_cdouble_cint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set specular material color.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setDrawStyle_cunsigned()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set drawing style.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setBackCulling_cbool()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Specify whether back-facing facets can be culled.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setBlending_cbool()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Turn on/off blending.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawTriangle()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a triangle width (0,1,0), (0,0,0), (1,0,0) vertices.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_generateRandomTriangles_cint_cint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Generate certain number of 2D or 3D triangles with random coordinates. The vertex coordinates are in the [0..1] interval. Use translate(), rotate(),
	 * and scale() methods to modify this square (2D) and cube (3D).
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_renderObject_cu32_cbool()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Render the object with the specified handle.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_renderObjectTriangles_cu32_cbool_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Render specified number of triangles from an object with the given handle.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setAmbientLight_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set global ambient light parameters.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_removeLightSources()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Remove all light sources.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_addLightSource()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Add light source.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setLightSourcePosition_cint_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set position of the specified light source.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setLightSourceDiffuse_cint_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set diffuse light parameters for the specified light source.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_setLightSourceSpecular_cint_cdouble_cdouble_cdouble_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set specular light parameters for the specified light source.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_createDisplayList()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create a new display list. This will be the active list.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_finishDisplayList()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Finish the active display list.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_executeDisplayList_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Execute the specified display list.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawSphere_cdouble_cint_cint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a sphere.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawCylinder_cdouble_cdouble_cdouble_cint_cint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a cylinder.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawDisk_cdouble_cdouble_cint_cint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a disk.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawTeapot_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a teapot.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawCube_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a cube.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawTorus_cdouble_cdouble_cint_cint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a torus.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawDodecahedron_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a dodecahedron.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawOctahedron_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw an octahedron.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawTetrahedron_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw a tetrahedron.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test_drawIcosahedron_cdouble()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Draw an icosahedron.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test__registerRenderer_Renderer_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Register the specified renderer.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test__registerObject_ObjectData()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Register the specified object.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test__renderObject_cu32_cbool_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Render specified number of vertices from an object with the given handle.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test__refreshCamera()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Refresh camera setting in OpenGL.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test__setGLUDrawStyle_cvoid_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Map current draw style to draw style of GLU quadratics.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestOpenGLRenderingEngine::test__reportTriangles_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Report certain number of triangles being rendered to the corresponding render window. This is needed
	 * for window statistics.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestOpenGLRenderingEngine);
}
