
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestProcess.cpp
/// Test case implementation for class Process.

#include "../include/TestProcess.h"

namespace ParCompMarkTest
{

  void TestProcess::setUp()
  {
	std::string currentLogFile = "logs/TestProcess.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Constructor & destructor tests
  //

  void TestProcess::test_constructor()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Default constructor for Squirrel compatibility. Calling this constructor always raises an exception.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_constructor_cstd__string_Node_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Creates a process with a specified name.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_destructor()
  {

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  //
  // Method tests
  //

  void TestProcess::test_threadInitialize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Some init step as thread.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_threadFinalize()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Some finitiate step as thread.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_start()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Start the process.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_stop()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Stop the process.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_addContext()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Create and add a context to the context list.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_initPC()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Intialize PC functionality.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_openRenderWindow_cstd__string_cstd__string_cbool_cu32_cu32_cu32_cs32_cs32_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Open GLX render window for rendering.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_actualizeRenderWindow()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Actualize GLX render window on PC information (frame sizes etc).
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_setViewportForRendering()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Setup viewport for the rendering process based on the context properties.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_displayFrameletIcon()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Display small icon on to top-left corner of the GLX window indicating 
	 * the frame/framelet relationship for this process.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_initProcess()
  {

	/*
	 * You have to verify the following:
	 * 
	 * This is an initializing method. 
	 * Called at the start of the working process.
	 * Starts a Squirrel VM and executes the initialization code.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_runningProcess()
  {

	/*
	 * You have to verify the following:
	 * 
	 * This method achieves the "real functionality" of 
	 * the process. Called at every frame.
	 * Starts a Squirrel VM and executes the initialization code.
	 * 
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_setProcessTypeSq_cint()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Alternate squirrel setter of mProcessType.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_getProcessTypeSq()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Alternate squirrel setter of mProcessType.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_setBufferByName_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set mBuffer by name. mBuffer will be retrieved from the buffer container of the parent node by the name of the buffer.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_setFinito_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Set parameters to finite pc.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_task()
  {

	/*
	 * You have to verify the following:
	 * 
	 * What we do during rendering/compositing.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_refreshSortOrder()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Refresh the sort order of the framelet produced by this process.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestProcess::test_gatherStatistics()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Gather rendering statistics for the current frame.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestProcess);
}
