
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestStringConverter.cpp
/// Test case implementation for class StringConverter.

#include "../include/TestStringConverter.h"
#include "../../include/PCMFileSystemManager.h"

namespace ParCompMarkTest
{

  void TestStringConverter::setUp()
  {
	std::string currentLogFile = "logs/TestStringConverter.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Class method tests
  //

  void TestStringConverter::test_toString_cu8()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert u8 to string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toString_cu16()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert u16 to string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toString_cu32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert u32 to string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toString_cs8()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert s8 to string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toString_cs16()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert s16 to string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toString_cs32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert s32 to string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toString_cReal_cs32_cs32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert Real to string. If the precision is set, the real value is converted in fixed point notation scientific notation otherwise.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toString_cbool()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert bool to string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toString_cvoid_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert void * to string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toU32_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert string to u32.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_toReal_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert string to Real.
	 */

	std::string str1 = "3.14159";
	Real r1 = StringConverter::toReal(str1);

	CPPUNIT_ASSERT(::fabs(r1 - 3.14159) < 1e-5);
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_parsePointer_cstd__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Convert string to void *.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_trim_std__string()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Leave whitespaces from the beginning and the end of the string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test_tokenize_cstd__string_cchar_p()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Tokenize the specified string. Original source: http://www.digitalpeer.com/id/simple
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestStringConverter::test__fitFieldWidth_cstd__string_cs32()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Append empty spaces to fit to field width.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestStringConverter);
}
