
//
// This source file is a part of ParCompMark
// Parallel Compositing Benchmark Framework
//
// for latest info see http://parcompmark.sourceforge.net

//
// Copyright (C) 2006 IT2 ParCompMark Dev. Team
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/// @file TestTimer.cpp
/// Test case implementation for class Timer.

#include "../include/TestTimer.h"
#include "../../include/PCMFileSystemManager.h"

namespace ParCompMarkTest
{

  void TestTimer::setUp()
  {
	std::string currentLogFile = "logs/TestTimer.log";

	if(Logger::getInstance() && Logger::getInstance()->getLogFileName() != currentLogFile)
	 Logger::destroyInstance();

	if(!FileSystemManager::getInstance())
	{
	 FileSystemManager::createInstance();
	 FileSystemManager::getInstance()->setAppDirectory("./");
	 FileSystemManager::getInstance()->initialize();
	}

	if(!Logger::getInstance())
	{
	 Logger::createInstance();
	 Logger::getInstance()->setLogFileName(currentLogFile);
	 Logger::getInstance()->initialize();
	}
  }

 /*----------------------------------------------------------------------*/

  void TestTimer::tearDown()
  {
  }

 /*----------------------------------------------------------------------*/

  //
  // Class method tests
  //

  void TestTimer::test_getSystemTime()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return corrected system time in seconds.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestTimer::test_getApplicationTime()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return (uncorrected) application time (getUncorrectedSystemTime() - mStartTime) in seconds.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestTimer::test_getUncorrectedSystemTime()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return uncorrected system time in seconds.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestTimer::test_getTimeString_cbool_cbool_cbool_cbool_cReal()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return current time as a string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestTimer::test_getDateString_cbool_cbool_cbool_cReal()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return current date as a string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestTimer::test_getTimeDateString_cbool_cbool_cbool_cbool_cbool_cbool_cbool_cReal()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Return current time and date as a string.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  void TestTimer::test_sleep_cReal()
  {

	/*
	 * You have to verify the following:
	 * 
	 * Sleep process for the specified seconds.
	 */

	CPPUNIT_FAIL("Implement this test!");
  }

 /*----------------------------------------------------------------------*/

  // To register the suite we add:
  /// \skip CPPUNIT_TEST_SUITE_REGISTRATION
  CPPUNIT_TEST_SUITE_REGISTRATION(TestTimer);
}
